<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/PTree/Display.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/PTree/Display.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/PTree/Display.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_PTree_Display_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_PTree_Display_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/PTree.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">{</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/PTree.html" title="namespace Synopsis::PTree">PTree</a></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="comment">//. The Display class provides an annotated view of the ptree,</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="comment">//. for debugging purposes</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/Display.html" title="class Synopsis::PTree::Display">Display</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">Visitor</a></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">{</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">  <a href="" title="member function Synopsis::PTree::Display::Display(std::ostream&amp;,bool)">Display</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;os, <span class="keyword">bool</span> encoded);</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#display_lconst.Node_S_r" title="member function Synopsis::PTree::Display::display(const Node*)">display</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *);</span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lAtom_S_r" title="member function Synopsis::PTree::Display::visit(Atom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">Atom</a> *);</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lList_S_r" title="member function Synopsis::PTree::Display::visit(List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *);</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">  <span class="comment">// atoms...</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lDupAtom_S_r" title="member function Synopsis::PTree::Display::visit(DupAtom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DupAtom.html" title="class Synopsis::PTree::DupAtom">DupAtom</a> *);</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">  <span class="comment">// ...lists...</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lBrace_S_r" title="member function Synopsis::PTree::Display::visit(Brace*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Brace.html" title="class Synopsis::PTree::Brace">Brace</a> *);</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lBlock_S_r" title="member function Synopsis::PTree::Display::visit(Block*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">Block</a> *b) { <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lAtom_S_r" title="member function Synopsis::PTree::Display::visit(Atom*)">visit</a>(static_cast&lt;Brace *&gt;(<a href="" title="parameter b">b</a>));}</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lClassBody_S_r" title="member function Synopsis::PTree::Display::visit(ClassBody*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ClassBody.html" title="class Synopsis::PTree::ClassBody">ClassBody</a> *b) { <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lAtom_S_r" title="member function Synopsis::PTree::Display::visit(Atom*)">visit</a>(static_cast&lt;Brace *&gt;(<a href="" title="parameter b">b</a>));}</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lDeclarator_S_r" title="member function Synopsis::PTree::Display::visit(Declarator*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Declarator.html" title="class Synopsis::PTree::Declarator">Declarator</a> *l) { <a href="../../../Scopes/Synopsis/PTree/Display.html#print_encoded_lList_S_r" title="member function Synopsis::PTree::Display::print_encoded(List*)">print_encoded</a>(<a href="" title="parameter l">l</a>);}</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lName_S_r" title="member function Synopsis::PTree::Display::visit(Name*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Name.html" title="class Synopsis::PTree::Name">Name</a> *l) { <a href="../../../Scopes/Synopsis/PTree/Display.html#print_encoded_lList_S_r" title="member function Synopsis::PTree::Display::print_encoded(List*)">print_encoded</a>(<a href="" title="parameter l">l</a>);}</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#visit_lFstyleCastExpr_S_r" title="member function Synopsis::PTree::Display::visit(FstyleCastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FstyleCastExpr.html" title="class Synopsis::PTree::FstyleCastExpr">FstyleCastExpr</a> *l) { <a href="../../../Scopes/Synopsis/PTree/Display.html#print_encoded_lList_S_r" title="member function Synopsis::PTree::Display::print_encoded(List*)">print_encoded</a>(<a href="" title="parameter l">l</a>);}</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#newline_l_r" title="member function Synopsis::PTree::Display::newline()">newline</a>();</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  <span class="keyword">bool</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#too_deep_l_r" title="member function Synopsis::PTree::Display::too_deep()">too_deep</a>();</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Display.html#print_encoded_lList_S_r" title="member function Synopsis::PTree::Display::print_encoded(List*)">print_encoded</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *);</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/PTree/Display.html#my_os" title="data member Synopsis::PTree::Display::my_os">my_os</a>;</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">  <a href="" title="typedef size_t">size_t</a>        <a href="../../../Scopes/Synopsis/PTree/Display.html#my_indent" title="data member Synopsis::PTree::Display::my_indent">my_indent</a>;</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">  <span class="keyword">bool</span>          <a href="../../../Scopes/Synopsis/PTree/Display.html#my_encoded" title="data member Synopsis::PTree::Display::my_encoded">my_encoded</a>;</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">};</span>
<a id="line46"></a><span class="lineno"> 46</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html" title="class Synopsis::PTree::RTTIDisplay">RTTIDisplay</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">Visitor</a></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">{</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  <a href="" title="member function Synopsis::PTree::RTTIDisplay::RTTIDisplay(std::ostream&amp;,bool)">RTTIDisplay</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;os, <span class="keyword">bool</span> encoded);</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#display_lconst.Node_S_r" title="member function Synopsis::PTree::RTTIDisplay::display(const Node*)">display</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *);</span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#visit_lAtom_S_r" title="member function Synopsis::PTree::RTTIDisplay::visit(Atom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">Atom</a> *);</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#visit_lList_S_r" title="member function Synopsis::PTree::RTTIDisplay::visit(List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *);</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#visit_lDupAtom_S_r" title="member function Synopsis::PTree::RTTIDisplay::visit(DupAtom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DupAtom.html" title="class Synopsis::PTree::DupAtom">DupAtom</a> *);</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#newline_l_r" title="member function Synopsis::PTree::RTTIDisplay::newline()">newline</a>();</span>
<a id="line59"></a><span class="lineno"> 59</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#my_os" title="data member Synopsis::PTree::RTTIDisplay::my_os">my_os</a>;</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">  <a href="" title="typedef size_t">size_t</a>        <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#my_indent" title="data member Synopsis::PTree::RTTIDisplay::my_indent">my_indent</a>;</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">  <span class="keyword">bool</span>          <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#my_encoded" title="data member Synopsis::PTree::RTTIDisplay::my_encoded">my_encoded</a>;</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">};</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html" title="class Synopsis::PTree::DotFileGenerator">DotFileGenerator</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">PTree::Visitor</a></span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">{</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">  <a href="" title="member function Synopsis::PTree::DotFileGenerator::DotFileGenerator(std::ostream&amp;)">DotFileGenerator</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;);</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html#write_lconst.Node_S_r" title="member function Synopsis::PTree::DotFileGenerator::write(const Node*)">write</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *ptree);</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html#visit_lAtom_S_r" title="member function Synopsis::PTree::DotFileGenerator::visit(Atom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">PTree::Atom</a> *a);</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html#visit_lList_S_r" title="member function Synopsis::PTree::DotFileGenerator::visit(List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List</a> *l);</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html#my_os" title="data member Synopsis::PTree::DotFileGenerator::my_os">my_os</a>;</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">};</span>
<a id="line76"></a><span class="lineno"> 76</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line"><span class="comment">//. Display the given parse tree segment on the given output stream.</span></span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line"><span class="comment">//. If 'encoded' is set to 'true', print encoded names / types</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="comment">//. on appropriate nodes. If 'typeinfo' is set to 'true', print</span></span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line"><span class="comment">//. the class names of the nodes.</span></span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">inline <span class="keyword">void</span> <a href="" title="function Synopsis::PTree::display(const Node*,std::ostream&amp;,bool,bool)">display</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *node, <a href="" title="typedef std::ostream">std::ostream</a> &amp;os,</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">		    <span class="keyword">bool</span> encoded = false, <span class="keyword">bool</span> typeinfo = false)</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">{</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">  <span class="keyword">if</span> (<a href="" title="parameter typeinfo">typeinfo</a>)</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  {</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html" title="class Synopsis::PTree::RTTIDisplay">RTTIDisplay</a> <a href="" title="local variable `if::d">d</a>(os, encoded);</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <a href="" title="local variable `if::d">d</a>.<a href="../../../Scopes/Synopsis/PTree/RTTIDisplay.html#display_lconst.Node_S_r" title="member function Synopsis::PTree::RTTIDisplay::display(const Node*)">display</a>(<a href="" title="parameter node">node</a>);</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">  }</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">  <span class="keyword">else</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  {</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">    <a href="../../../Scopes/Synopsis/PTree/Display.html" title="class Synopsis::PTree::Display">Display</a> <a href="" title="local variable `else::d">d</a>(os, encoded);</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">    <a href="" title="local variable `else::d">d</a>.<a href="../../../Scopes/Synopsis/PTree/Display.html#display_lconst.Node_S_r" title="member function Synopsis::PTree::Display::display(const Node*)">display</a>(<a href="" title="parameter node">node</a>);</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">  }</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">}</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line"><span class="comment">//. Generate a dot file for the given parse tree segment.</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">inline <span class="keyword">void</span> <a href="" title="function Synopsis::PTree::generate_dot_file(const Node*,std::ostream&amp;)">generate_dot_file</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node const</a> *node, <a href="" title="typedef std::ostream">std::ostream</a> &amp;os)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">{</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html" title="class Synopsis::PTree::DotFileGenerator">DotFileGenerator</a> <a href="" title="local variable generator">generator</a>(os);</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  <a href="" title="local variable generator">generator</a>.<a href="../../../Scopes/Synopsis/PTree/DotFileGenerator.html#write_lconst.Node_S_r" title="member function Synopsis::PTree::DotFileGenerator::write(const Node*)">write</a>(<a href="" title="parameter node">node</a>);</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">}</span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">}</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">}</span>
<a id="line105"></a><span class="lineno">105</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
